# src "Includes" http://savonet.sourceforge.net/doc-svn/language.html
%include "/home/liquidsoap/secrets.liq" # requires double quotes

# concat strings -> https://bytesandbones.wordpress.com/2014/07/18/liquidsoap-concat-strings/
# random weigths -> src "A simple radio" http://savonet.sourceforge.net/doc-svn/quick_start.html
def template(text, freq)
  msg = random(
    weights = [1, 2, 10],
    [
      single("say: #{text}"), # requires double quotes
      sine(480.0, amplitude = 0.1, duration = 0.5),
      blank(duration = 1.0)
    ])
  add([sine(freq, amplitude = 0.05), msg], normalize = true)
end

# A simple cross-fade -> src "Switch-based transitions" http://savonet.sourceforge.net/doc-svn/cookbook.html
def crossfade(a,b)
  add(normalize=false,
      [ sequence([ blank(duration=1.),
                   fade.initial(duration=2.,b) ]),
        fade.final(duration=1.,a) ])
end

# TODO add jingles (at least to say we are running a random playlist)
default_source = playlist('/home/liquidsoap/playlist.txt')

default_transition = [
  {% for p in podcasts -%}
  {# filter: allow only mp3 to care about streaming -#}
  {% if p.audio.lurl[-3:] == 'mp3' -%}
  crossfade, # source: {{ p.title }}
  {% endif -%}
  {% endfor -%}
  crossfade # default source
]

# at the moment all signals have audio_to_stereo() function (I don't know if I can do this in another place), reason: The case of mono files is often surprising. Since liquidsoap does not implicitly convert between media formats, input files must be stereo if the output expects stereo data. As a result, people often get this error message on files which they expected to play correctly. The simple way to fix this is to use the audio_to_stereo() operator to allow any kind of audio on its input, and produce stereo as expected on its output. -> src https://www.liquidsoap.info/doc-dev/faq.html
signal = switch(
  track_sensitive = false,
  transitions = default_transition,[
    {% for p in podcasts -%}
    {# filter: allow only mp3 to care about streaming -#}
    {% if (p.audio.lurl[-3:] == 'mp3') and (p.live == False) -%}
    ({ {{ p.lstart }}-{{p.lstop}} }, audio_to_stereo(single('{{ p.audio.lurl }}'))),
    {% endif -%}
    {% if p.live == True -%}
    ({ {{ p.lstart }}-{{p.lstop}} }, blank()),
    {% endif -%}
    {% endfor -%}
    ({ true }, default_source)
  ])

output.icecast(%mp3(bitrate=256),
     description = 'executes the scheduled radio',
     password = icecast_passwd, mount = 'schedule.mp3',
     mksafe(signal))
